## raspberrypi-userland 0~20200520%2Bgit2fe4ca3

=== host_applications/vmcs/test_apps/mmalplay/Makefile ===
all:
	gcc -O3  mmalplay.c playback.c -o mmalplay -lmmal -lmmal_core  -lmmal_util  -I/opt/vc/include/  -L/opt/vc/lib/ -lpthread -lvcos

## raspberrypi-userland 0~20200520+git2fe4ca3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(vmcs_host_apps)

SET(PROJECT_VER_MAJOR 1)
SET(PROJECT_VER_MINOR 0)
SET(PROJECT_VER_PATCH 0)
SET(PROJECT_VER "${PROJECT_VER_MAJOR}.${PROJECT_VER_MINOR}.${PROJECT_VER_PATCH}")
SET(PROJECT_APIVER "${PROJECT_VER}")

set(BUILD_MMAL TRUE)
set(BUILD_MMAL_APPS TRUE)

set(vmcs_root ${PROJECT_SOURCE_DIR})
get_filename_component(VIDEOCORE_ROOT . ABSOLUTE)

set(VCOS_PTHREADS_BUILD_SHARED TRUE)

include(makefiles/cmake/global_settings.cmake)
include(makefiles/cmake/arm-linux.cmake)
include(makefiles/cmake/vmcs.cmake)

enable_language(ASM)

# Global include paths
include_directories(host_applications/framework)
include_directories(${PROJECT_SOURCE_DIR})
include_directories(interface/vcos/pthreads)
include_directories(interface/vmcs_host/linux)
include_directories(interface/vmcs_host)
include_directories(interface/vmcs_host/khronos)
include_directories(interface/khronos/include)
include_directories(${PROJECT_BINARY_DIR})
include_directories(interface/vchiq_arm)
#include_directories(tools/inet_transport)
include_directories(host_support/include)

# Global compiler flags
if(CMAKE_COMPILER_IS_GNUCC)
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-multichar -Wall -Wno-unused-but-set-variable -fPIC")
endif()

add_definitions(-D_REENTRANT)
add_definitions(-DUSE_VCHIQ_ARM -DVCHI_BULK_ALIGN=1 -DVCHI_BULK_GRANULARITY=1)
add_definitions(-DOMX_SKIP64BIT)
add_definitions(-DEGL_SERVER_DISPMANX)
add_definitions(-D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64)
add_definitions(-D_GNU_SOURCE)

# do we actually need this?
add_definitions(-D__VIDEOCORE4__)
add_definitions(-DTV_SUPPORTED_MODE_NO_DEPRECATED)

# add_definitions(-DKHRONOS_CLIENT_LOGGING)

# Check for OpenWF-C value set via command line
if(KHRONOS_EGL_PLATFORM MATCHES "openwfc")
   add_definitions(-DKHRONOS_EGL_PLATFORM_OPENWFC)
endif()

# List of subsidiary CMakeLists
add_subdirectory(interface/vcos)
add_subdirectory(interface/vmcs_host)
add_subdirectory(interface/vchiq_arm)
if(NOT ARM64)
   add_subdirectory(interface/khronos)
endif()

#add_subdirectory(opensrc/tools/lua)
if(BUILD_MMAL)
   include_directories(interface/mmal)
   add_subdirectory(interface/mmal)
   add_subdirectory(containers)
endif()

# VidTex supports Android and Linux
if(NOT ARM64)
   if(BUILD_MMAL_APPS)
   add_subdirectory(host_applications/android/apps/vidtex)
   endif(BUILD_MMAL_APPS)
endif()

if(NOT ARM64)
   add_subdirectory(middleware/openmaxil)
endif()

# 3d demo code
#if(NOT ANDROID)
#   add_subdirectory(thirdparty/applications/demos)
#   add_subdirectory(opensrc/applications/demos)
#endif()

#if(ENABLE_3D_TESTS)
#   add_subdirectory(thirdparty/applications/test)
#endif()

# FIXME: we should use a pre-packaged version of freetype
# rather than the one included in the repo.
#add_subdirectory(opensrc/helpers/freetype)
#add_subdirectory(${PROJECT_SOURCE_DIR}/opensrc/helpers/fonts/ttf-bitstream-vera)

# VMCS Host Applications
#add_subdirectory(host_applications/framework)

# add_subdirectory(interface/vchiq/test/win32)

# Apps and libraries supporting Camera Tuning Tool
#add_subdirectory(tools/inet_transport/linux)
#add_subdirectory(host_support/vcstandalone)

# add linux apps
add_subdirectory(host_applications/linux)
add_subdirectory(opensrc/helpers/libfdt)
add_subdirectory(helpers/dtoverlay)

set(vmcs_host_apps_VERSION_MAJOR 1)
set(vmcs_host_apps_VERSION_MINOR 0)

include_directories("${PROJECT_BINARY_DIR}")
include(FindPkgConfig QUIET)
if(PKG_CONFIG_FOUND)
	# Produce a pkg-config file
	foreach(PCFILE bcm_host.pc brcmegl.pc brcmglesv2.pc brcmvg.pc vcsm.pc mmal.pc)
		configure_file("pkgconfig/${PCFILE}.in" "${PCFILE}" @ONLY)
		install(FILES       "${CMAKE_CURRENT_BINARY_DIR}/${PCFILE}"
			DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig")
	endforeach()
endif()
# Remove cache entry, if one added by command line
unset(KHRONOS_EGL_PLATFORM CACHE)

=== containers/asf/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

add_library(reader_asf ${LIBRARY_TYPE} asf_reader.c)

target_link_libraries(reader_asf containers)

install(TARGETS reader_asf DESTINATION ${VMCS_PLUGIN_DIR})

add_library(writer_asf ${LIBRARY_TYPE} asf_writer.c)

target_link_libraries(writer_asf containers)

install(TARGETS writer_asf DESTINATION ${VMCS_PLUGIN_DIR})

=== containers/mpga/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

add_library(reader_mpga ${LIBRARY_TYPE} mpga_reader.c)

target_link_libraries(reader_mpga containers)

install(TARGETS reader_mpga DESTINATION ${VMCS_PLUGIN_DIR})

=== containers/qsynth/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

add_library(reader_qsynth ${LIBRARY_TYPE} qsynth_reader.c)

target_link_libraries(reader_qsynth containers)

install(TARGETS reader_qsynth DESTINATION ${VMCS_PLUGIN_DIR})

=== containers/rtp/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

set(rtp_SRCS ${rtp_SRCS} rtp_reader.c)
set(rtp_SRCS ${rtp_SRCS} rtp_h264.c)
set(rtp_SRCS ${rtp_SRCS} rtp_mpeg4.c)
set(rtp_SRCS ${rtp_SRCS} rtp_base64.c)
add_library(reader_rtp ${LIBRARY_TYPE} ${rtp_SRCS})

target_link_libraries(reader_rtp containers)

install(TARGETS reader_rtp DESTINATION ${VMCS_PLUGIN_DIR})

=== host_applications/linux/CMakeLists.txt ===
# linux apps

add_subdirectory(libs/bcm_host)
add_subdirectory(apps/gencmd)
add_subdirectory(apps/tvservice)
add_subdirectory(apps/vcmailbox)
add_subdirectory(apps/raspicam)
add_subdirectory(libs/sm)
if(NOT ARM64)
   add_subdirectory(apps/smem)
endif()
add_subdirectory(libs/debug_sym)
add_subdirectory(apps/dtoverlay)
add_subdirectory(apps/dtmerge)

if(ALL_APPS)
 add_subdirectory(apps/vcdbg)
 add_subdirectory(libs/elftoolchain)
 # add_subdirectory(apps/smct)
 add_subdirectory(apps/edid_parser)
 add_subdirectory(apps/hello_pi)
endif()

=== interface/mmal/CMakeLists.txt ===
# We support building both static and shared libraries
if (NOT DEFINED LIBRARY_TYPE)
set(LIBRARY_TYPE SHARED)
endif (NOT DEFINED LIBRARY_TYPE)

add_definitions(-Wall -Werror)

add_library(mmal SHARED util/mmal_util.c)

add_subdirectory(core)
add_subdirectory(util)
add_subdirectory(vc)
add_subdirectory(components)
if(NOT ARM64)
   add_subdirectory(openmaxil)
   add_subdirectory(client)
endif()

target_link_libraries(mmal mmal_core mmal_util mmal_vc_client vcos mmal_components)

install(TARGETS mmal DESTINATION lib)
install(FILES
   mmal.h
   mmal_buffer.h
   mmal_clock.h
   mmal_common.h
   mmal_component.h
   mmal_encodings.h
   mmal_events.h
   mmal_format.h
   mmal_logging.h
   mmal_parameters.h
   mmal_parameters_audio.h
   mmal_parameters_camera.h
   mmal_parameters_clock.h
   mmal_parameters_common.h
   mmal_parameters_video.h
   mmal_pool.h mmal_port.h
   mmal_queue.h
   mmal_types.h
   DESTINATION include/interface/mmal
)

# Test apps
if(BUILD_MMAL_APPS)
add_subdirectory(test)
endif(BUILD_MMAL_APPS)

=== interface/vmcs_host/CMakeLists.txt ===

# interface/vmcs_host

# not working in release build
# add_definitions(-Werror)

# vc_vchi_gencmd.c has a type-punning problem in vc_gencmd_read_response
add_definitions(-fno-strict-aliasing)

add_library(vchostif
            ${VMCS_TARGET}/vcfilesys.c ${VMCS_TARGET}/vcmisc.c
            vc_vchi_gencmd.c vc_vchi_filesys.c vc_vchi_gpuserv.c
            vc_vchi_tvservice.c vc_vchi_cecservice.c
            vc_vchi_dispmanx.c vc_service_common.c)
#            ${VMCS_TARGET}/vmcs_main.c
#  vc_vchi_haud.c
#add_library(bufman            vc_vchi_bufman.c            )
set(INSTALL_TARGETS vchostif)

if(NOT ARM64)
	# OpenMAX/IL component service
	add_library(vcilcs
		    vcilcs.c vcilcs_in.c vcilcs_out.c vcilcs_common.c)

	# ILCS pulls in EGL for the ILCS/EGL surface API support
	target_link_libraries(vcilcs brcmEGL brcmGLESv2 khrn_client vchiq_arm vcos)
	set(INSTALL_TARGETS ${INSTALL_TARGETS} vcilcs)
endif()

# vchostif needs ilcore as well (vmcs_main pulls it in)
target_link_libraries(vchostif vchiq_arm vcos)

#target_link_libraries(bufman WFC)

install(TARGETS ${INSTALL_TARGETS} DESTINATION lib)

=== middleware/openmaxil/CMakeLists.txt ===
# =============================================================================
# Copyright (c) 2012 Broadcom Europe Limited.
# All rights reserved.
#
# FILE DESCRIPTION
# CMake build file for OpenMAX IL.
# =============================================================================

cmake_minimum_required (VERSION 2.8)

if (VIDEOCORE_SIMULATION)

   # VC-simulation build.

   add_library (openmaxil SHARED
 #               core/ilcore.c
                core/ril_top.c
                core/ilmalloc.c
                core/ilvlls.c
                core/ilfifo.c
                core/ilutil.c)

   add_subdirectory (components)

else ()

   # Host build.
   #
   # Provides a host OpenMAX IL core as well as access to OpenMAX IL core and
   # components running on Videocore with the help of the ILCS library.
   #
   # Ideally, we would want the native 64-bit OMX_TICKS datatype but on
   # Videocore, structures are word-aligned, even if they have 64-bit members.
   #
   #    remove_definitions(-DOMX_SKIP64BIT)

   add_definitions (-DVLL_PATH_PREFIX="${VMCS_PLUGIN_DIR}/")

   add_library (openmaxil SHARED 
                ../../host_applications/framework/common/ilcore.c
#                core/ilcore.c
#                core/ril_top.c
#                core/ilmalloc.c
#                core/ilvlls.c
#                core/ilfifo.c
                )

   target_link_libraries (openmaxil vcilcs vcos dl)

endif ()

install (TARGETS openmaxil DESTINATION lib)

=== interface/mmal/client/CMakeLists.txt ===
add_subdirectory(brcmjpeg)

=== interface/mmal/openmaxil/CMakeLists.txt ===
add_library (mmal_omx ${LIBRARY_TYPE}
   mmalomx_core.c
   mmalomx_logging.c
   mmalomx_commands.c
   mmalomx_buffer.c
   mmalomx_marks.c
   mmalomx_roles.c
   mmalomx_parameters.c
   mmalomx_registry.c
)

add_library (mmal_omxutil ${LIBRARY_TYPE}
   mmalomx_util_params.c
   mmalomx_util_params_audio.c
   mmalomx_util_params_video.c
   mmalomx_util_params_camera.c
   mmalomx_util_params_misc.c
)

target_link_libraries (mmal_omx mmal_omxutil mmal_core mmal_util vcos)

=== host_applications/linux/apps/gencmd/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if (WIN32)
   set(VCOS_PLATFORM win32)
else ()
   set(VCOS_PLATFORM pthreads)
   add_definitions(-Wall -Werror)
endif ()

include_directories( ../../../.. 
                     ../../../../interface/vcos
                     ../../../../interface/vcos/${VCOS_PLATFORM} )

#add_subdirectory( ../../../../interface/vcos/${VCOS_PLATFORM} vcos)
#add_subdirectory( ../../bin/gencmd)

add_executable(vcgencmd gencmd.c)
target_link_libraries(vcgencmd vcos vchiq_arm vchostif)
install(TARGETS vcgencmd RUNTIME DESTINATION bin)

=== debian/changelog ===
raspberrypi-userland (0~20200520+git2fe4ca3-0ubuntu3~20.04.1) focal; urgency=medium

  * Correct vcio (and associated) permissions on focal (LP: #1958563)

 -- Dave Jones <dave.jones@canonical.com>  Tue, 25 Jan 2022 13:45:06 +0000

raspberrypi-userland (0~20200520+git2fe4ca3-0ubuntu3~20.04) focal; urgency=medium

  * Backport to focal (LP: #1883111)
  * d/copyright audit
  * Added d/p/no-specific-libgps.patch to use whatever libgps the system
    provides
  * Excluded the various /usr/bin/containers_* test binaries from
    libraspberrypi-bin
  * Added d/librasperrypi0.symbols file
  * Fixed pkgconfig paths in d/p/fix-multiarch-dir.patch

 -- Dave Jones <dave.jones@canonical.com>  Mon, 19 Oct 2020 20:36:07 +0100

raspberrypi-userland (0~20200520+git2fe4ca3-0ubuntu2) groovy; urgency=medium

  * Don't build libGL/EGL/GLES/etc. libraries with names conflicting with the
    mesa copies (LP: #1891613)
  * Tidied up some lintian warnings in armhf build

 -- Dave Jones <dave.jones@canonical.com>  Fri, 14 Aug 2020 12:50:20 +0100

raspberrypi-userland (0~20200520+git2fe4ca3-0ubuntu1) groovy; urgency=medium

  * Ubuntu port (LP: #1883111)
  * Added:
    - d/p/add-custom-bootdir.patch to customize boot path
    - d/p/fix-format-overflow.patch to fix gcc-10 compiler error
    - d/p/fix-multiarch-dir.patch to build output in multi-arch paths
    - d/p/no-dma-buf.patch to exclude Linux headers from source

 -- Dave Jones <dave.jones@canonical.com>  Tue, 28 Jul 2020 12:09:02 +0100

=== debian/control ===
Source: raspberrypi-userland
Priority: optional
XSBC-Original-Maintainer: Serge Schneider <serge@raspberrypi.org>
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends:
  debhelper (>= 11),
  cmake,
  linux-libc-dev,
  libgps-dev,
  pkg-config
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/raspberrypi/userland

Package: libraspberrypi0
Section: libs
Architecture: armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: EGL/GLES/OpenVG/etc. libraries for the Raspberry Pi's VideoCore IV
 This package contains implementations of EGL, OpenGL ES, OpenVG, OpenWF
 Composition, and others for the Raspberry Pi's VideoCore IV multimedia
 processor.

Package: libraspberrypi-dev
Section: libdevel
Architecture: armhf arm64
Depends: libraspberrypi0 (= ${binary:Version}), ${misc:Depends}
Description: EGL/GLES/OpenVG/etc. libraries for the Raspberry Pi's VideoCore IV (headers)
 This package contains headers, example code, and other development files for
 implementations of EGL, OpenGL ES, OpenVG, OpenWF Composition, and others for
 the Raspberry Pi's VideoCore IV multimedia processor.

Package: libraspberrypi-bin
Section: misc
Architecture: armhf arm64
Depends: libraspberrypi0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, device-tree-compiler
Suggests: libgps-dev
Description: Miscellaneous Raspberry Pi utilities
 This package contains various utilities for interacting with the Raspberry
 Pi's VideoCore IV.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

ifeq ($(DEB_HOST_ARCH),arm64)
arm64=YES
else
arm64=NO
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DVMCS_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DARM64=$(arm64)

TEST_BINARIES := \
	vcsmem \
	vchiq_test \
	mmal_vc_diag

override_dh_install:
	dh_install
	# Remove all the small (largely undocumented) test binaries with
	# rather generic names
	rm debian/libraspberrypi-bin/usr/bin/containers_*
	mkdir -p debian/libraspberrypi-bin/usr/lib/userland
	for file in $(TEST_BINARIES); do \
		if [ -f debian/libraspberrypi-bin/usr/bin/$${file} ]; then \
			mv debian/libraspberrypi-bin/usr/bin/$${file} \
				debian/libraspberrypi-bin/usr/lib/userland/ ; \
		fi ; \
	done

## raspberrypi-userland 0~20211124%2Bgit14b90ff

=== containers/flash/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

add_library(reader_flv ${LIBRARY_TYPE} flv_reader.c)

target_link_libraries(reader_flv containers)

install(TARGETS reader_flv DESTINATION ${VMCS_PLUGIN_DIR})

## raspberrypi-userland 0~20211124+git14b90ff

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,9 +8,13 @@
 SET(PROJECT_VER "${PROJECT_VER_MAJOR}.${PROJECT_VER_MINOR}.${PROJECT_VER_PATCH}")
 SET(PROJECT_APIVER "${PROJECT_VER}")
 
-set(BUILD_MMAL TRUE)
-set(BUILD_MMAL_APPS TRUE)
-
+if(ARM64)
+   set(BUILD_MMAL FALSE)
+   set(BUILD_MMAL_APPS FALSE)
+else()
+   set(BUILD_MMAL TRUE)
+   set(BUILD_MMAL_APPS TRUE)
+endif()
 set(vmcs_root ${PROJECT_SOURCE_DIR})
 get_filename_component(VIDEOCORE_ROOT . ABSOLUTE)
 
@@ -74,11 +78,9 @@
 endif()
 
 # VidTex supports Android and Linux
-if(NOT ARM64)
-   if(BUILD_MMAL_APPS)
-   add_subdirectory(host_applications/android/apps/vidtex)
-   endif(BUILD_MMAL_APPS)
-endif()
+if(BUILD_MMAL_APPS)
+add_subdirectory(host_applications/android/apps/vidtex)
+endif(BUILD_MMAL_APPS)
 
 if(NOT ARM64)
    add_subdirectory(middleware/openmaxil)

=== containers/CMakeLists.txt ===
SET( SOURCE_DIR . )

# We support building both static and shared libraries
if (NOT DEFINED LIBRARY_TYPE)
set(LIBRARY_TYPE SHARED)
endif (NOT DEFINED LIBRARY_TYPE)

# Make sure the compiler can find the necessary include files
include_directories (${SOURCE_DIR}/.. ${SOURCE_DIR}/../interface/vcos)

# Needed for the container loader
add_definitions(-DDL_PATH_PREFIX="${VMCS_PLUGIN_DIR}/")

SET( GCC_COMPILER_FLAGS -Wall -g -O2 -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wcast-qual -Wwrite-strings -Wundef )
SET( GCC_COMPILER_FLAGS ${GCC_COMPILER_FLAGS} -Wextra )#-Wno-missing-field-initializers )
SET( GCC_COMPILER_FLAGS ${GCC_COMPILER_FLAGS} -std=c99 -D_POSIX_C_SOURCE=200112L )
SET( GCC_COMPILER_FLAGS ${GCC_COMPILER_FLAGS} -Wno-missing-field-initializers )
SET( GCC_COMPILER_FLAGS ${GCC_COMPILER_FLAGS} -Wno-unused-value )

add_definitions( ${GCC_COMPILER_FLAGS} )

# Containers core library
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_io.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_io_helpers.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_codecs.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_utils.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_writer_utils.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_loader.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_filters.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_logging.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_uri.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_bits.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_list.c)
set(core_SRCS ${core_SRCS} ${SOURCE_DIR}/core/containers_index.c)

# Containers io library
set(io_SRCS ${io_SRCS} ${SOURCE_DIR}/io/io_file.c)
set(io_SRCS ${io_SRCS} ${SOURCE_DIR}/io/io_null.c)
set(io_SRCS ${io_SRCS} ${SOURCE_DIR}/io/io_net.c)
set(io_SRCS ${io_SRCS} ${SOURCE_DIR}/io/io_pktfile.c)
set(io_SRCS ${io_SRCS} ${SOURCE_DIR}/io/io_http.c)
add_definitions( -DENABLE_CONTAINER_IO_HTTP )

# Containers net library
if (DEFINED MSVC)
set(net_SRCS ${net_SRCS} ${SOURCE_DIR}/net/net_sockets_common.c)
set(net_SRCS ${net_SRCS} ${SOURCE_DIR}/net/net_sockets_win32.c)
elseif (DEFINED LINUX OR DEFINED UNIX)
set(net_SRCS ${net_SRCS} ${SOURCE_DIR}/net/net_sockets_common.c)
set(net_SRCS ${net_SRCS} ${SOURCE_DIR}/net/net_sockets_bsd.c)
else (DEFINED MSVC)
set(net_SRCS ${net_SRCS} ${SOURCE_DIR}/net/net_sockets_null.c)
endif (DEFINED MSVC)
set(extra_net_SRCS net_sockets_win32.c net_sockets_win32.h net_sockets_null.c)
add_custom_target(containers_net_extra ALL
    COMMAND touch ${extra_net_SRCS}
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/containers/net)

# Packetizers library
set(packetizers_SRCS ${packetizers_SRCS} ${SOURCE_DIR}/core/packetizers.c)
set(packetizers_SRCS ${packetizers_SRCS} ${SOURCE_DIR}/mpga/mpga_packetizer.c)
set(packetizers_SRCS ${packetizers_SRCS} ${SOURCE_DIR}/mpgv/mpgv_packetizer.c)
set(packetizers_SRCS ${packetizers_SRCS} ${SOURCE_DIR}/pcm/pcm_packetizer.c)
set(packetizers_SRCS ${packetizers_SRCS} ${SOURCE_DIR}/h264/avc1_packetizer.c)

add_library(containers ${LIBRARY_TYPE} ${core_SRCS} ${io_SRCS} ${net_SRCS} ${packetizers_SRCS})
target_link_libraries(containers vcos)
install(TARGETS containers DESTINATION lib)

set(container_readers)
set(container_writers)

# Container modules
add_subdirectory(mp4)
set(container_readers ${container_readers} reader_mp4)
set(container_writers ${container_writers} writer_mp4)
add_subdirectory(mpeg)
set(container_readers ${container_readers} reader_ps)
add_subdirectory(mpga)
set(container_readers ${container_readers} reader_mpga)
add_subdirectory(binary)
set(container_readers ${container_readers} reader_binary)
set(container_writers ${container_writers} writer_binary)
add_subdirectory(mkv)
set(container_readers ${container_readers} reader_mkv)
add_subdirectory(wav)
set(container_readers ${container_readers} reader_wav)
add_subdirectory(asf)
set(container_readers ${container_readers} reader_asf)
set(container_writers ${container_writers} writer_asf)
add_subdirectory(flash)
set(container_readers ${container_readers} reader_flv)
add_subdirectory(avi)
set(container_readers ${container_readers} reader_avi)
set(container_writers ${container_writers} writer_avi)
add_subdirectory(rtp)
set(container_readers ${container_readers} reader_rtp)
add_subdirectory(rtsp)
set(container_readers ${container_readers} reader_rtsp)
add_subdirectory(rcv)
set(container_readers ${container_readers} reader_rcv)
add_subdirectory(rv9)
set(container_readers ${container_readers} reader_rv9)
add_subdirectory(qsynth)
set(container_readers ${container_readers} reader_qsynth)
add_subdirectory(simple)
set(container_readers ${container_readers} reader_simple)
set(container_writers ${container_writers} writer_simple)
add_subdirectory(raw)
set(container_readers ${container_readers} reader_raw_video)
set(container_writers ${container_writers} writer_raw_video)
add_subdirectory(dummy)
set(container_writers ${container_writers} writer_dummy)

add_subdirectory(metadata/id3)
set(container_readers ${container_readers} reader_metadata_id3)

if (${LIBRARY_TYPE} STREQUAL STATIC)
target_link_libraries(containers ${container_readers} ${container_writers})
endif (${LIBRARY_TYPE} STREQUAL STATIC)

# Test apps
add_subdirectory(test)

=== containers/mkv/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

add_library(reader_mkv ${LIBRARY_TYPE} matroska_reader.c)

target_link_libraries(reader_mkv containers)

install(TARGETS reader_mkv DESTINATION ${VMCS_PLUGIN_DIR})

=== containers/wav/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

add_library(reader_wav ${LIBRARY_TYPE} wav_reader.c)

target_link_libraries(reader_wav containers)

install(TARGETS reader_wav DESTINATION ${VMCS_PLUGIN_DIR})

=== interface/vmcs_host/CMakeLists.txt ===
--- 
+++ 
@@ -8,8 +8,8 @@
 add_definitions(-fno-strict-aliasing)
 
 add_library(vchostif
-            ${VMCS_TARGET}/vcfilesys.c ${VMCS_TARGET}/vcmisc.c
-            vc_vchi_gencmd.c vc_vchi_filesys.c vc_vchi_gpuserv.c
+            ${VMCS_TARGET}/vcmisc.c
+            vc_vchi_gencmd.c vc_vchi_gpuserv.c
             vc_vchi_tvservice.c vc_vchi_cecservice.c
             vc_vchi_dispmanx.c vc_service_common.c)
 #            ${VMCS_TARGET}/vmcs_main.c

=== interface/vcos/generic/CMakeLists.txt ===

set (HEADERS
   vcos_common.h
   vcos_generic_blockpool.h
   vcos_generic_event_flags.h
   vcos_generic_named_sem.h
   vcos_generic_quickslow_mutex.h
   vcos_generic_reentrant_mtx.h
   vcos_generic_tls.h
   vcos_joinable_thread_from_plain.h
   vcos_latch_from_sem.h
   vcos_mem_from_malloc.h
   vcos_mutexes_are_reentrant.h
   vcos_thread_reaper.h
)

foreach (header ${HEADERS})
   configure_file ("${header}" "${VCOS_HEADERS_BUILD_DIR}/generic/${header}" COPYONLY)
endforeach ()

install (FILES ${HEADERS} DESTINATION include/interface/vcos/generic)

=== opensrc/helpers/libfdt/CMakeLists.txt ===
include_directories(.)

add_library(fdt
            fdt.c 
            fdt_empty_tree.c
            fdt_ro.c
            fdt_rw.c
            fdt_sw.c
            fdt_strerror.c
            fdt_wip.c)

INSTALL(FILES)

=== host_applications/linux/apps/dtmerge/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

get_filename_component (VIDEOCORE_ROOT ../../../.. ABSOLUTE)
include (${VIDEOCORE_ROOT}/makefiles/cmake/global_settings.cmake)

if (NOT WIN32)
   add_definitions(-Wall -Werror)
endif ()

include_directories (
   ${VIDEOCORE_HEADERS_BUILD_DIR}
   ${VIDEOCORE_ROOT}
   ${VIDEOCORE_ROOT}/opensrc/helpers/libfdt
   ${VIDEOCORE_ROOT}/helpers/dtoverlay
)

add_executable(dtmerge dtmerge.c)
target_link_libraries(dtmerge dtovl)

install(TARGETS dtmerge RUNTIME DESTINATION bin)
install(FILES dtmerge.1 DESTINATION man/man1)

=== host_applications/linux/apps/dtoverlay/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

get_filename_component (VIDEOCORE_ROOT ../../../.. ABSOLUTE)
include (${VIDEOCORE_ROOT}/makefiles/cmake/global_settings.cmake)

if (NOT WIN32)
   add_definitions(-Wall -Werror)
endif ()

include_directories (
   ${VIDEOCORE_HEADERS_BUILD_DIR}
   ${VIDEOCORE_ROOT}
   ${VIDEOCORE_ROOT}/opensrc/helpers/libfdt
   ${VIDEOCORE_ROOT}/helpers/dtoverlay
)

add_executable(dtoverlay dtoverlay_main.c utils.c)
target_link_libraries(dtoverlay dtovl)
install(TARGETS dtoverlay RUNTIME DESTINATION bin)
install(FILES dtoverlay.1 DESTINATION man/man1)

add_custom_command(TARGET dtoverlay POST_BUILD COMMAND ln;-sf;dtoverlay;dtparam)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtparam DESTINATION bin)
install(FILES dtparam.1 DESTINATION man/man1)

set(DTOVERLAY_SCRIPTS dtoverlay-pre dtoverlay-post)
install(PROGRAMS ${DTOVERLAY_SCRIPTS} DESTINATION bin)

=== host_applications/linux/apps/hello_pi/Makefile ===
all: apps

libs/ilclient/libilclient.a:
	$(MAKE) -C libs/ilclient

libs/vgfont/libvgfont.a:
	$(MAKE) -C libs/vgfont

libs/revision/librevision.a:
	$(MAKE) -C libs/revision

apps: libs/ilclient/libilclient.a libs/vgfont/libvgfont.a libs/revision/librevision.a
	$(MAKE) -C hello_world
	$(MAKE) -C hello_triangle
	$(MAKE) -C hello_triangle2
	$(MAKE) -C hello_video
	$(MAKE) -C hello_audio
	$(MAKE) -C hello_font
	$(MAKE) -C hello_dispmanx
	$(MAKE) -C hello_tiger
	$(MAKE) -C hello_encode
	$(MAKE) -C hello_jpeg
	$(MAKE) -C hello_videocube
	$(MAKE) -C hello_teapot
	$(MAKE) -C hello_fft
	$(MAKE) -C hello_mmal_encode

clean:
	$(MAKE) -C libs/ilclient clean
	$(MAKE) -C libs/vgfont clean
	$(MAKE) -C libs/revision clean
	$(MAKE) -C hello_world clean
	$(MAKE) -C hello_triangle clean
	$(MAKE) -C hello_triangle2 clean
	$(MAKE) -C hello_video clean
	$(MAKE) -C hello_audio clean
	$(MAKE) -C hello_font clean
	$(MAKE) -C hello_dispmanx clean
	$(MAKE) -C hello_tiger clean
	$(MAKE) -C hello_encode clean
	$(MAKE) -C hello_jpeg clean
	$(MAKE) -C hello_videocube clean
	$(MAKE) -C hello_teapot clean
	$(MAKE) -C hello_fft clean
	$(MAKE) -C hello_mmal_encode clean

=== host_applications/linux/apps/raspicam/CMakeLists.txt ===

# raspistill/raspivid/raspiyuv

SET(COMPILE_DEFINITIONS -Werror)

# Set --no-as-needed to stop the linker discarding mmal_vc_client
# as it can't see that the constructor registers a load of functionality
# with the MMAL core.
SET( CMAKE_EXE_LINKER_FLAGS "-Wl,--no-as-needed" )

include_directories(${PROJECT_SOURCE_DIR}/host_applications/linux/libs/bcm_host/include)
include_directories(${PROJECT_SOURCE_DIR}/host_applications/linux/apps/raspicam/)
include_directories(${PROJECT_SOURCE_DIR}/host_applications/linux/libs/sm)

# Find the commit hash of the build and pass to the compiler
execute_process(
  COMMAND git log -1 --abbrev=12 --format=%h
  OUTPUT_VARIABLE GIT_COMMIT_ID
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
add_definitions("-DGIT_COMMIT_ID=\"${GIT_COMMIT_ID}\"")

# Determine if we are tainted
if(NOT SKIP_TAINTED_CHECK)
execute_process(
  COMMAND bash "-c" "git ls-files -m | wc -l"
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_TAINTED
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
add_definitions("-DGIT_TAINTED=${GIT_TAINTED}")
endif(NOT SKIP_TAINTED_CHECK)

set (COMMON_SOURCES
   RaspiCamControl.c
   RaspiCLI.c
   RaspiPreview.c
   RaspiCommonSettings.c
   RaspiHelpers.c
   RaspiGPS.c
   libgps_loader.c)

if(NOT ARM64)
  set (EGL_LIBS brcmGLESv2 brcmEGL)
  set (EGL_SOURCES RaspiTex.c RaspiTexUtil.c tga.c)
  set (GL_SCENE_SOURCES
     gl_scenes/models.c
     gl_scenes/mirror.c
     gl_scenes/yuv.c
     gl_scenes/sobel.c
     gl_scenes/square.c
     gl_scenes/teapot.c
     gl_scenes/vcsm_square.c)
else()
  set (EGL_SOURCES RaspiTexStub.c)
endif()

add_executable(raspistill ${COMMON_SOURCES} RaspiStill.c  ${EGL_SOURCES} ${GL_SCENE_SOURCES} )
add_executable(raspiyuv   ${COMMON_SOURCES} RaspiStillYUV.c)
add_executable(raspivid   ${COMMON_SOURCES} RaspiVid.c)
add_executable(raspividyuv  ${COMMON_SOURCES} RaspiVidYUV.c)

set (MMAL_LIBS mmal_core mmal_util mmal_vc_client)
target_link_libraries(raspistill ${MMAL_LIBS} vcos bcm_host ${EGL_LIBS} m dl)
target_link_libraries(raspiyuv   ${MMAL_LIBS} vcos bcm_host m)
target_link_libraries(raspivid   ${MMAL_LIBS} vcos bcm_host m)
target_link_libraries(raspividyuv   ${MMAL_LIBS} vcos bcm_host m)

install(TARGETS raspistill raspiyuv raspivid raspividyuv RUNTIME DESTINATION bin)
install(FILES raspistill.1 raspiyuv.1 raspivid.1 raspividyuv.1 DESTINATION man/man1)
install(FILES raspicam.7 DESTINATION man/man7)

=== debian/changelog ===
raspberrypi-userland (0~20211124+git14b90ff-0ubuntu2) jammy; urgency=medium

  * Fix udev rules for vcio and vchiq (LP: #1958563)
  * Add dma_heap and rpivid rules for better libcamera support

 -- Dave Jones <dave.jones@canonical.com>  Thu, 20 Jan 2022 19:03:13 +0000

raspberrypi-userland (0~20211124+git14b90ff-0ubuntu1) jammy; urgency=medium

  * Bump to current version on RaspiOS Bullseye (LP: #1950289):
    - Fixes the tvservice application (LP: #1944541)
    - d/p/fix-multiarch-dir.patch: refreshed context
    - d/p/add-custom-bootdir.patch: refreshed context
    - d/p/fix-format-overflow.patch: merged upstream
    - d/p/libraspberrypi0.install:
      - split into armhf and arm64 variants
      - removed all the plugins/containers entries from the arm64 variant now
        that MMAL is no longer built for arm64
    - d/p/libraspberrypi0.symbols.arm{hf,64}:
      - removed all hostfs and vcfiled calls
      - removed mmal calls for allocation / lookup / release of client
        components and contexts
    - d/p/libraspberrypi0.symbols.arm64:
      - removed all MMAL related entries
    - d/libraspberrypi0.lintian-overrides.arm64:
      - removed all MMAL related entries
    - d/libraspberrypi-bin.manpages:
      - split into armhf and arm64 variants
      - removed all raspicam related manpages from the arm64 version
    - d/*.[17]:
      - man-pages were merged upstream; these are now in the orig-tar
    - d/rules:
      - fix install on arm64 where containers_* binaries are no longer built

 -- Dave Jones <dave.jones@canonical.com>  Wed, 21 Jul 2021 14:03:05 +0100

raspberrypi-userland (0~20200520+git2fe4ca3-0ubuntu3~ppa2) hirsute; urgency=medium

  * d/copyright audit
  * Added d/p/no-specific-libgps.patch to use whatever libgps the system
    provides
  * Excluded the various /usr/bin/containers_* test binaries from
    libraspberrypi-bin
  * Added d/librasperrypi0.symbols file
  * Fixed pkgconfig paths in d/p/fix-multiarch-dir.patch

 -- Dave Jones <dave.jones@canonical.com>  Mon, 19 Oct 2020 20:36:07 +0100

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 	dh_install
 	# Remove all the small (largely undocumented) test binaries with
 	# rather generic names
-	rm debian/libraspberrypi-bin/usr/bin/containers_*
+	rm -f debian/libraspberrypi-bin/usr/bin/containers_*
 	mkdir -p debian/libraspberrypi-bin/usr/lib/userland
 	for file in $(TEST_BINARIES); do \
 		if [ -f debian/libraspberrypi-bin/usr/bin/$${file} ]; then \

## raspberrypi-userland 0~20220324+gitc4fd1b8

=== containers/mp4/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

add_library(reader_mp4 ${LIBRARY_TYPE} mp4_reader.c)

target_link_libraries(reader_mp4 containers)

install(TARGETS reader_mp4 DESTINATION ${VMCS_PLUGIN_DIR})

add_library(writer_mp4 ${LIBRARY_TYPE} mp4_writer.c)

target_link_libraries(writer_mp4 containers)

install(TARGETS writer_mp4 DESTINATION ${VMCS_PLUGIN_DIR})

=== containers/metadata/id3/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

add_library(reader_metadata_id3 ${LIBRARY_TYPE} id3_metadata_reader.c)

target_link_libraries(reader_metadata_id3 containers)

install(TARGETS reader_metadata_id3 DESTINATION ${VMCS_PLUGIN_DIR})

=== host_applications/linux/apps/hello_pi/CMakeLists.txt ===
set(BUILD_FONT FALSE)

include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_SOURCE_DIR}/host_applications/linux/libs/bcm_host/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libs/ilclient)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libs/vgfont)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libs/revision)

set(ILCLIENT_SRCS libs/ilclient/ilclient.c libs/ilclient/ilcore.c)
add_library(ilclient ${ILCLIENT_SRCS})

set(REVISION_SRCS libs/revision/revision.c )
add_library(revision ${REVISION_SRCS})

set(HELLO_PI_LIBS ilclient openmaxil bcm_host vcos vchiq_arm revision)

add_subdirectory(hello_world)
add_subdirectory(hello_video)
add_subdirectory(hello_audio)
add_subdirectory(hello_triangle)
add_subdirectory(hello_triangle2)
add_subdirectory(hello_dispmanx)
add_subdirectory(hello_tiger)
add_subdirectory(hello_encode)
add_subdirectory(hello_jpeg)
add_subdirectory(hello_videocube)
add_subdirectory(hello_teapot)

if(BUILD_FONT)
set(VGFONT_SRCS libs/vgfont/font.c libs/vgfont/vgft.c libs/vgfont/graphics.c)
set_source_files_properties(${VGFONT_SRCS} PROPERTIES COMPILE_DEFINITIONS)
add_library(vgfont ${VGFONT_SRCS})

add_subdirectory(hello_font)
endif(BUILD_FONT)

=== host_applications/linux/apps/hello_pi/hello_triangle/CMakeLists.txt ===
set(EXEC hello_triangle.bin)
set(SRCS triangle.c)

add_executable(${EXEC} ${SRCS})
target_link_libraries(${EXEC} ${HELLO_PI_LIBS})

install(TARGETS ${EXEC}
        RUNTIME DESTINATION bin)

=== debian/changelog ===
raspberrypi-userland (0~20220324+gitc4fd1b8-0ubuntu1~22.04.1) jammy; urgency=medium

  * SRU of kinetic version
  * Fix lintian-overrides to use arch-specific flags, ensuring both the armhf
    and arm64 versions can be simultaneously installed (LP: #1973285)
  * Fix Multi-Arch spec on libraspberrypi-bin and libraspberrypi-dev
  * d/libraspberrypi0.symbols.* add Build-Depends-Package
  * Don't embed Vera.ttf in libraspberrypi-dev examples; symlink to the one
    from ttf-bitstream-vera and Suggest: that package instead
  * Ensure examples in libraspberrypi-dev are not compressed

 -- Dave Jones <dave.jones@canonical.com>  Thu, 26 May 2022 14:22:37 +0100

## raspberrypi-userland 0~20230913%2Bgitcc1ca18

=== containers/mpeg/CMakeLists.txt ===
# Container module needs to go in as a plugins so different prefix
# and install path
set(CMAKE_SHARED_LIBRARY_PREFIX "")

# Make sure the compiler can find the necessary include files
include_directories (../..)

add_library(reader_ps ${LIBRARY_TYPE} ps_reader.c)

target_link_libraries(reader_ps containers)

install(TARGETS reader_ps DESTINATION ${VMCS_PLUGIN_DIR})
